/* -------------------------------------------------------------------- */
/* Programma: vestiti      Modulo: funzioni.c    Autore: Enrico Lodolo  */
/* Creato il 02/07/2003                    Ultima modifica: 02/07/2003  */
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funzioni.h"

/* -------------------------------------------------------------------- */
/*  1. Definizione funzione leggi()                                     */
/*     Legge da nomefile i dati delle righe nella struttura vestiti     */
/* -------------------------------------------------------------------- */

int leggi(char nomefile[], vestiti* vs)
{
  vestito v;
  FILE* f;

  f = fopen(nomefile, "r");

  if (f==NULL)
    return FALSE;
  else
  {
    vs->num = 0;

    while (fscanf(f, "%d %d %d %f",
	         &v.tipo, &v.taglia, &v.quant, &v.prezzo)!=EOF)
    {
      vs->v[vs->num] = v;
      vs->num++;
    }
    fclose(f);
    return TRUE;
  }
}

/* -------------------------------------------------------------------- */
/*  2. Definizione funzione estrai()                                    */
/*     Estrae i vestiti di una determinata taglia                       */
/* ---------------------------------------------------------------------*/

void estrai(int taglia, vestiti vs, vestiti *es)
{
	es->num = 0;

	for (int i=0; i<vs.num; i++)
	{
		if (vs.v[i].taglia==taglia)
		{
			es->v[es->num] = vs.v[i];
			es->num++;
		}
	}
}

/* -------------------------------------------------------------------- */
/*  3. Definizione funzione quant()                                     */
/*     Restituisce la quantit totale di vestiti di una data taglia     */
/* ---------------------------------------------------------------------*/

int quant(vestiti vs)
{
	int q = 0;

	for (int i=0; i<vs.num; i++)
		q+=vs.v[i].quant;

	return q;
}

/* -------------------------------------------------------------------- */
/*  3. Definizione funzione prezzo()                                    */
/*     Restituisce il prezzo totale dei vestiti di una data taglia      */
/* ---------------------------------------------------------------------*/

float prezzo(vestiti vs)
{
	float p = 0.0;

	for (int i=0; i<vs.num; i++)
		p+=vs.v[i].quant*vs.v[i].prezzo;

	return p;
}

/* ------------------------------------------------------------------- */
/*  7. Definizione funzione scrivi()                                   */
/*     Scrive nel file filename i contatori degli accessi              */
/* --------------------------------------------------------------------*/

int scrivi(char nomefile[], vestiti vs)
{
  FILE *f;
	vestiti es;
	int q;
	float p;

  f = fopen(nomefile, "w");

  if (f==NULL) return FALSE;
  else
  {
    for(int i=42; i<=54; i=i+2)
		{
			estrai(i,vs,&es);

			q = quant(es);
			p = prezzo(es);

      fprintf(f, "%d %d %f\n", i, q, p);
		}
    fclose(f);
    return TRUE;
  }
}

/* ------------------------------------------------------------------- */
/*  Definizione funzione errore() (non richiesta ma utile)             */
/*  Scrive a video un messaggio di errore e termina programma con      */
/*  valore di ritorno uguale al codice di errore                       */
/* --------------------------------------------------------------------*/

void errore(int n, char msg[])
{
  printf("%s\n",msg);
  exit(n);
}
